//+------------------------------------------------------------------+
//|                                                 GradientDemo.mq5 |
//|                                  Copyright 2023, MetaQuotes Ltd. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2023, MetaQuotes Ltd."
#property link      "https://www.mql5.com"
#property version   "1.00"

#include <Canvas\iCanvas_CB.mqh> // https://www.mql5.com/ru/code/22164
#include <OK Color Space.mqh>    // https://www.mql5.com/ru/code/44050

int X,Y1,Y2,Y3,Y4,Y5,Y6,Width;
float Saturation=90;
float Lightness=50;
int OnInit()
  {
   ReSize();
   Draw();
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {   
  }
//+------------------------------------------------------------------+
void OnTick()
  {
  }
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
   if(id==CHARTEVENT_MOUSE_MOVE && lparam>=X && lparam<=(X+Width) && ((dparam>=Y5 && dparam<=(Y5+22)) || (dparam>=Y6 && dparam<=(Y6+22)))) {
      if(dparam>=Y6) Lightness = 100.f*float(lparam-X)/Width;
      else Saturation = 100.f*float(lparam-X)/Width;
      Draw();
   }
   if(id==CHARTEVENT_CHART_CHANGE)  {
      ReSize();
      Draw();
   }
  }
//+------------------------------------------------------------------+
void Draw() {

   //static uint clr[] = {0xFF00FF00,0xFFFFFF00,0xFFFF0000,0xFFFF00FF,0xFF0000FF,0xFF00FFFF};
   static uint clr[] = {0xFFFF0000,0xFFFFFF00,0xFF00FF00,0xFF00FFFF,0xFF0000FF,0xFFFF00FF,0xFFFF0000};
   Canvas.Erase(0x00FFFFFF);  
   int x=X; 
   for (double g = 0; g<=1; g+=1.0/Width) {
      uint c = Canvas.Grad(g,clr);
      Canvas.LineVertical(x++,Y1,Y2,c);
   }
   x=X; 
   for (float g = 0; g<=1; g+=1.f/Width) {
      uint c = ColorToARGB(OKhslToColor(g*360,Saturation,Lightness));
      Canvas.LineVertical(x++,Y3,Y4,c);
   }
   int d1 = int(Saturation*Width/100.f);
   int d2 = int(Lightness*Width/100.f);
   Canvas.Rectangle(X,Y5,X+Width,Y5+22,0x808000FF);
   Canvas.FillRectangle(X+d1-11,Y5,X+d1+11,Y5+22,0x808000FF);
   _CommXY(X+d1-22,Y5+25,DoubleToString(Saturation,2));
   Canvas.Rectangle(X,Y6,X+Width,Y6+22,0x808000FF);
   Canvas.FillRectangle(X+d2-11,Y6,X+d2+11,Y6+22,0x808000FF);
   _CommXY(X+d2-22,Y6+25,DoubleToString(Lightness,2));
   _CommXY(X,Y3-25,"Hue");
   _CommXY(X,Y5-25,"Saturation");
   _CommXY(X,Y6-25,"Lightness");
   _CommXY(X,Y4+5,"0");
   _CommXY(X+Width-20,Y4+5,"360");
   Canvas.Update();
}
void ReSize() {
   Width  = int(W.Width*0.7);
   X = (W.Width-Width)/2;
   Y1 = W.Height/6;
   Y2 = W.Height/3;
   Y3 = Y1+W.Height/4;
   Y4 = Y2+W.Height/4;
   Y5 = Y4+W.Height/10;
   Y6 = Y5+80;
}